﻿using Microsoft.AspNetCore.Mvc;
using TicketsApps.Models;
using TicketsApps.services;

namespace TicketsApps.Controllers
{
    public class BookTicketController : Controller
    {
        public IActionResult Index()
        {
            IronPdf.License.LicenseKey = "";
            return View();
        }

        [HttpPost]
        public ActionResult Index(ClientModel model)
        {
            if (ModelState.IsValid)
            {
                ClientServices.AddClient(model);
                return RedirectToAction("TicketView");
            }
            return View(model);
        }

        public ActionResult TicketView()
        {
            var rand = new Random();
            var client = ClientServices.GetClient();
            var ticket = new TicketModel()
            {
                TicketNumber = rand.Next(100000, 999999),
                TicketDate = DateTime.Now,
                Email = client.Email,
                Name = client.Name,
                Phone = client.Phone
            };

            return View(ticket);
        }

        [HttpPost]
        public ActionResult TicketView(TicketModel model)
        {
            IronPdf.Installation.TempFolderPath = $@"{Directory.GetParent}/irontemp/";
            IronPdf.Installation.LinuxAndDockerDependenciesAutoConfig = true;
            var html = this.RenderViewAsync("_TicketPdf", model);
            var renderer = new IronPdf.ChromePdfRenderer();
            using var pdf = renderer.RenderHtmlAsPdf(html.Result, @"wwwroot/css");
            return File(pdf.Stream.ToArray(), "application/pdf");
        }
    }
}
